/* shutdown-dialog.c generated by valac 0.20.1, the Vala compiler
 * generated from shutdown-dialog.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2013 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Robert Ancell <robert.ancell@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <lightdm.h>
#include "config.h"
#include <gdk/gdk.h>


#define TYPE_SHUTDOWN_DIALOG_TYPE (shutdown_dialog_type_get_type ())

#define TYPE_SHUTDOWN_DIALOG (shutdown_dialog_get_type ())
#define SHUTDOWN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHUTDOWN_DIALOG, ShutdownDialog))
#define SHUTDOWN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHUTDOWN_DIALOG, ShutdownDialogClass))
#define IS_SHUTDOWN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHUTDOWN_DIALOG))
#define IS_SHUTDOWN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHUTDOWN_DIALOG))
#define SHUTDOWN_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHUTDOWN_DIALOG, ShutdownDialogClass))

typedef struct _ShutdownDialog ShutdownDialog;
typedef struct _ShutdownDialogClass ShutdownDialogClass;
typedef struct _ShutdownDialogPrivate ShutdownDialogPrivate;

#define TYPE_DIALOG_BUTTON (dialog_button_get_type ())
#define DIALOG_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIALOG_BUTTON, DialogButton))
#define DIALOG_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIALOG_BUTTON, DialogButtonClass))
#define IS_DIALOG_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIALOG_BUTTON))
#define IS_DIALOG_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIALOG_BUTTON))
#define DIALOG_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIALOG_BUTTON, DialogButtonClass))

typedef struct _DialogButton DialogButton;
typedef struct _DialogButtonClass DialogButtonClass;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DialogButtonPrivate DialogButtonPrivate;

typedef enum  {
	SHUTDOWN_DIALOG_TYPE_LOGOUT,
	SHUTDOWN_DIALOG_TYPE_SHUTDOWN,
	SHUTDOWN_DIALOG_TYPE_RESTART
} ShutdownDialogType;

struct _ShutdownDialog {
	GtkFixed parent_instance;
	ShutdownDialogPrivate * priv;
};

struct _ShutdownDialogClass {
	GtkFixedClass parent_class;
};

struct _ShutdownDialogPrivate {
	cairo_surface_t* corner_surface;
	cairo_surface_t* left_surface;
	cairo_surface_t* top_surface;
	cairo_pattern_t* corner_pattern;
	cairo_pattern_t* left_pattern;
	cairo_pattern_t* top_pattern;
	GtkBox* vbox;
	DialogButton* close_button;
	GtkBox* button_box;
};

struct _DialogButton {
	GtkButton parent_instance;
	DialogButtonPrivate * priv;
};

struct _DialogButtonClass {
	GtkButtonClass parent_class;
};

struct _DialogButtonPrivate {
	gchar* inactive_filename;
	gchar* active_filename;
	GtkImage* i;
	GtkLabel* l;
};


static gpointer shutdown_dialog_parent_class = NULL;
static gpointer dialog_button_parent_class = NULL;

GType shutdown_dialog_type_get_type (void) G_GNUC_CONST;
GType shutdown_dialog_get_type (void) G_GNUC_CONST;
GType dialog_button_get_type (void) G_GNUC_CONST;
#define SHUTDOWN_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SHUTDOWN_DIALOG, ShutdownDialogPrivate))
enum  {
	SHUTDOWN_DIALOG_DUMMY_PROPERTY
};
#define SHUTDOWN_DIALOG_BORDER_SIZE 30
#define SHUTDOWN_DIALOG_CLOSE_OFFSET 3
ShutdownDialog* shutdown_dialog_new (ShutdownDialogType type);
ShutdownDialog* shutdown_dialog_construct (GType object_type, ShutdownDialogType type);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static DialogButton* shutdown_dialog_add_button (ShutdownDialog* self, const gchar* text, const gchar* inactive_filename, const gchar* active_filename);
static void ____lambda29_ (ShutdownDialog* self);
static void _____lambda29__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void ____lambda30_ (ShutdownDialog* self);
static void _____lambda30__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void ___lambda31_ (ShutdownDialog* self);
static void ____lambda31__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void ___lambda32_ (ShutdownDialog* self);
static void ____lambda32__gtk_button_clicked (GtkButton* _sender, gpointer self);
DialogButton* dialog_button_new (const gchar* inactive_filename, const gchar* active_filename, GtkLabel* label);
DialogButton* dialog_button_construct (GType object_type, const gchar* inactive_filename, const gchar* active_filename, GtkLabel* label);
static void __lambda33_ (ShutdownDialog* self);
static void ___lambda33__gtk_button_clicked (GtkButton* _sender, gpointer self);
void shutdown_dialog_focus_next (ShutdownDialog* self);
void shutdown_dialog_focus_prev (ShutdownDialog* self);
void shutdown_dialog_cancel (ShutdownDialog* self);
static void shutdown_dialog_real_size_allocate (GtkWidget* base, GtkAllocation* allocation);
static gboolean shutdown_dialog_real_draw (GtkWidget* base, cairo_t* c);
void dash_box_cairo_rounded_rectangle (cairo_t* c, gdouble x, gdouble y, gdouble width, gdouble height, gdouble radius);
static gboolean shutdown_dialog_real_button_press_event (GtkWidget* base, GdkEventButton* event);
static void shutdown_dialog_finalize (GObject* obj);
#define DIALOG_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIALOG_BUTTON, DialogButtonPrivate))
enum  {
	DIALOG_BUTTON_DUMMY_PROPERTY
};
static gboolean dialog_button_real_enter_notify_event (GtkWidget* base, GdkEventCrossing* event);
static gboolean dialog_button_real_leave_notify_event (GtkWidget* base, GdkEventCrossing* event);
static gboolean dialog_button_real_focus_in_event (GtkWidget* base, GdkEventFocus* event);
static gboolean dialog_button_real_focus_out_event (GtkWidget* base, GdkEventFocus* event);
static gboolean dialog_button_real_draw (GtkWidget* base, cairo_t* c);
static void dialog_button_finalize (GObject* obj);


GType shutdown_dialog_type_get_type (void) {
	static volatile gsize shutdown_dialog_type_type_id__volatile = 0;
	if (g_once_init_enter (&shutdown_dialog_type_type_id__volatile)) {
		static const GEnumValue values[] = {{SHUTDOWN_DIALOG_TYPE_LOGOUT, "SHUTDOWN_DIALOG_TYPE_LOGOUT", "logout"}, {SHUTDOWN_DIALOG_TYPE_SHUTDOWN, "SHUTDOWN_DIALOG_TYPE_SHUTDOWN", "shutdown"}, {SHUTDOWN_DIALOG_TYPE_RESTART, "SHUTDOWN_DIALOG_TYPE_RESTART", "restart"}, {0, NULL, NULL}};
		GType shutdown_dialog_type_type_id;
		shutdown_dialog_type_type_id = g_enum_register_static ("ShutdownDialogType", values);
		g_once_init_leave (&shutdown_dialog_type_type_id__volatile, shutdown_dialog_type_type_id);
	}
	return shutdown_dialog_type_type_id__volatile;
}


static void _vala_PangoFontDescription_free (PangoFontDescription* self) {
	g_boxed_free (pango_font_description_get_type (), self);
}


static void ____lambda29_ (ShutdownDialog* self) {
	GError * _inner_error_ = NULL;
	{
		lightdm_suspend (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch24_g_error;
		}
		g_signal_emit_by_name (self, "close");
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("shutdown-dialog.vala:93: Failed to suspend: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally24:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _____lambda29__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	____lambda29_ (self);
}


static void ____lambda30_ (ShutdownDialog* self) {
	GError * _inner_error_ = NULL;
	{
		lightdm_hibernate (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch25_g_error;
		}
		g_signal_emit_by_name (self, "close");
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("shutdown-dialog.vala:110: Failed to hibernate: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally25:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void _____lambda30__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	____lambda30_ (self);
}


static void ___lambda31_ (ShutdownDialog* self) {
	GError * _inner_error_ = NULL;
	{
		lightdm_restart (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch26_g_error;
		}
		g_signal_emit_by_name (self, "close");
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("shutdown-dialog.vala:128: Failed to restart: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally26:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ____lambda31__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	___lambda31_ (self);
}


static void ___lambda32_ (ShutdownDialog* self) {
	GError * _inner_error_ = NULL;
	{
		lightdm_shutdown (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch27_g_error;
		}
		g_signal_emit_by_name (self, "close");
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("shutdown-dialog.vala:145: Failed to shutdown: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally27:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ____lambda32__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	___lambda32_ (self);
}


static void __lambda33_ (ShutdownDialog* self) {
	g_signal_emit_by_name (self, "close");
}


static void ___lambda33__gtk_button_clicked (GtkButton* _sender, gpointer self) {
	__lambda33_ (self);
}


ShutdownDialog* shutdown_dialog_construct (GType object_type, ShutdownDialogType type) {
	ShutdownDialog * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	const gchar* _tmp4_ = NULL;
	GtkLabel* _tmp5_;
	GtkLabel* title_label;
	GtkLabel* _tmp6_;
	PangoFontDescription* _tmp7_ = NULL;
	PangoFontDescription* _tmp8_;
	GtkLabel* _tmp9_;
	GdkRGBA _tmp10_ = {0};
	GtkLabel* _tmp11_;
	GtkBox* _tmp12_;
	GtkLabel* _tmp13_;
	gchar* text = NULL;
	ShutdownDialogType _tmp14_;
	const gchar* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* label;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	PangoFontDescription* _tmp24_ = NULL;
	PangoFontDescription* _tmp25_;
	GtkLabel* _tmp26_;
	GdkRGBA _tmp27_ = {0};
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkBox* _tmp30_;
	GtkLabel* _tmp31_;
	GtkBox* _tmp32_;
	GtkBox* _tmp33_;
	GtkBox* _tmp34_;
	GtkBox* _tmp35_;
	ShutdownDialogType _tmp36_;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp64_ = FALSE;
	gchar* _tmp73_ = NULL;
	gchar* _tmp74_;
	gchar* _tmp75_ = NULL;
	gchar* _tmp76_;
	DialogButton* _tmp77_;
	DialogButton* _tmp78_;
	DialogButton* _tmp79_;
	DialogButton* _tmp80_;
	DialogButton* _tmp81_;
	self = (ShutdownDialog*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 10);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->vbox);
	self->priv->vbox = _tmp0_;
	_tmp1_ = self->priv->vbox;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->vbox;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->vbox;
	gtk_container_set_border_width ((GtkContainer*) _tmp3_, (guint) 20);
	_tmp4_ = _ ("Shutdown");
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
	g_object_ref_sink (_tmp5_);
	title_label = _tmp5_;
	_tmp6_ = title_label;
	_tmp7_ = pango_font_description_from_string ("Ubuntu Light 15");
	_tmp8_ = _tmp7_;
	gtk_widget_override_font ((GtkWidget*) _tmp6_, _tmp8_);
	__vala_PangoFontDescription_free0 (_tmp8_);
	_tmp9_ = title_label;
	_tmp10_.red = (gdouble) 1.0f;
	_tmp10_.green = (gdouble) 1.0f;
	_tmp10_.blue = (gdouble) 1.0f;
	_tmp10_.alpha = (gdouble) 1.0f;
	gtk_widget_override_color ((GtkWidget*) _tmp9_, GTK_STATE_FLAG_NORMAL, &_tmp10_);
	_tmp11_ = title_label;
	gtk_misc_set_alignment ((GtkMisc*) _tmp11_, 0.0f, 0.5f);
	_tmp12_ = self->priv->vbox;
	_tmp13_ = title_label;
	gtk_box_pack_start (_tmp12_, (GtkWidget*) _tmp13_, FALSE, FALSE, (guint) 0);
	_tmp14_ = type;
	if (_tmp14_ == SHUTDOWN_DIALOG_TYPE_SHUTDOWN) {
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		_tmp15_ = _ ("Goodbye. Would you like to…");
		_tmp16_ = g_strdup (_tmp15_);
		_g_free0 (text);
		text = _tmp16_;
	} else {
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
		GtkLabel* _tmp19_;
		_tmp17_ = _ ("Are you sure you want to shut down the computer?");
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (text);
		text = _tmp18_;
		_tmp19_ = title_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp19_, TRUE);
	}
	_tmp20_ = text;
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
	g_object_ref_sink (_tmp21_);
	label = _tmp21_;
	_tmp22_ = label;
	gtk_label_set_line_wrap (_tmp22_, TRUE);
	_tmp23_ = label;
	_tmp24_ = pango_font_description_from_string ("Ubuntu Light 12");
	_tmp25_ = _tmp24_;
	gtk_widget_override_font ((GtkWidget*) _tmp23_, _tmp25_);
	__vala_PangoFontDescription_free0 (_tmp25_);
	_tmp26_ = label;
	_tmp27_.red = (gdouble) 1.0f;
	_tmp27_.green = (gdouble) 1.0f;
	_tmp27_.blue = (gdouble) 1.0f;
	_tmp27_.alpha = (gdouble) 1.0f;
	gtk_widget_override_color ((GtkWidget*) _tmp26_, GTK_STATE_FLAG_NORMAL, &_tmp27_);
	_tmp28_ = label;
	gtk_misc_set_alignment ((GtkMisc*) _tmp28_, 0.0f, 0.5f);
	_tmp29_ = label;
	gtk_widget_set_visible ((GtkWidget*) _tmp29_, TRUE);
	_tmp30_ = self->priv->vbox;
	_tmp31_ = label;
	gtk_box_pack_start (_tmp30_, (GtkWidget*) _tmp31_, FALSE, FALSE, (guint) 0);
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 20);
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->button_box);
	self->priv->button_box = _tmp32_;
	_tmp33_ = self->priv->button_box;
	gtk_widget_set_visible ((GtkWidget*) _tmp33_, TRUE);
	_tmp34_ = self->priv->vbox;
	_tmp35_ = self->priv->button_box;
	gtk_box_pack_start (_tmp34_, (GtkWidget*) _tmp35_, FALSE, FALSE, (guint) 0);
	_tmp36_ = type;
	if (_tmp36_ == SHUTDOWN_DIALOG_TYPE_SHUTDOWN) {
		gboolean _tmp37_ = FALSE;
		gboolean _tmp46_ = FALSE;
		_tmp37_ = lightdm_get_can_suspend ();
		if (_tmp37_) {
			const gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_;
			gchar* _tmp41_ = NULL;
			gchar* _tmp42_;
			DialogButton* _tmp43_ = NULL;
			DialogButton* _tmp44_;
			DialogButton* button;
			DialogButton* _tmp45_;
			_tmp38_ = _ ("Suspend");
			_tmp39_ = g_build_filename (PKGDATADIR, "suspend.png", NULL);
			_tmp40_ = _tmp39_;
			_tmp41_ = g_build_filename (PKGDATADIR, "suspend_highlight.png", NULL);
			_tmp42_ = _tmp41_;
			_tmp43_ = shutdown_dialog_add_button (self, _tmp38_, _tmp40_, _tmp42_);
			_tmp44_ = _tmp43_;
			_g_free0 (_tmp42_);
			_g_free0 (_tmp40_);
			button = _tmp44_;
			_tmp45_ = button;
			g_signal_connect_object ((GtkButton*) _tmp45_, "clicked", (GCallback) _____lambda29__gtk_button_clicked, self, 0);
			_g_object_unref0 (button);
		}
		_tmp46_ = lightdm_get_can_hibernate ();
		if (_tmp46_) {
			const gchar* _tmp47_ = NULL;
			gchar* _tmp48_ = NULL;
			gchar* _tmp49_;
			gchar* _tmp50_ = NULL;
			gchar* _tmp51_;
			DialogButton* _tmp52_ = NULL;
			DialogButton* _tmp53_;
			DialogButton* button;
			DialogButton* _tmp54_;
			_tmp47_ = _ ("Hibernate");
			_tmp48_ = g_build_filename (PKGDATADIR, "hibernate.png", NULL);
			_tmp49_ = _tmp48_;
			_tmp50_ = g_build_filename (PKGDATADIR, "hibernate_highlight.png", NULL);
			_tmp51_ = _tmp50_;
			_tmp52_ = shutdown_dialog_add_button (self, _tmp47_, _tmp49_, _tmp51_);
			_tmp53_ = _tmp52_;
			_g_free0 (_tmp51_);
			_g_free0 (_tmp49_);
			button = _tmp53_;
			_tmp54_ = button;
			g_signal_connect_object ((GtkButton*) _tmp54_, "clicked", (GCallback) _____lambda30__gtk_button_clicked, self, 0);
			_g_object_unref0 (button);
		}
	}
	_tmp55_ = lightdm_get_can_restart ();
	if (_tmp55_) {
		const gchar* _tmp56_ = NULL;
		gchar* _tmp57_ = NULL;
		gchar* _tmp58_;
		gchar* _tmp59_ = NULL;
		gchar* _tmp60_;
		DialogButton* _tmp61_ = NULL;
		DialogButton* _tmp62_;
		DialogButton* button;
		DialogButton* _tmp63_;
		_tmp56_ = _ ("Restart");
		_tmp57_ = g_build_filename (PKGDATADIR, "restart.png", NULL);
		_tmp58_ = _tmp57_;
		_tmp59_ = g_build_filename (PKGDATADIR, "restart_highlight.png", NULL);
		_tmp60_ = _tmp59_;
		_tmp61_ = shutdown_dialog_add_button (self, _tmp56_, _tmp58_, _tmp60_);
		_tmp62_ = _tmp61_;
		_g_free0 (_tmp60_);
		_g_free0 (_tmp58_);
		button = _tmp62_;
		_tmp63_ = button;
		g_signal_connect_object ((GtkButton*) _tmp63_, "clicked", (GCallback) ____lambda31__gtk_button_clicked, self, 0);
		_g_object_unref0 (button);
	}
	_tmp64_ = lightdm_get_can_shutdown ();
	if (_tmp64_) {
		const gchar* _tmp65_ = NULL;
		gchar* _tmp66_ = NULL;
		gchar* _tmp67_;
		gchar* _tmp68_ = NULL;
		gchar* _tmp69_;
		DialogButton* _tmp70_ = NULL;
		DialogButton* _tmp71_;
		DialogButton* button;
		DialogButton* _tmp72_;
		_tmp65_ = _ ("Shutdown");
		_tmp66_ = g_build_filename (PKGDATADIR, "shutdown.png", NULL);
		_tmp67_ = _tmp66_;
		_tmp68_ = g_build_filename (PKGDATADIR, "shutdown_highlight.png", NULL);
		_tmp69_ = _tmp68_;
		_tmp70_ = shutdown_dialog_add_button (self, _tmp65_, _tmp67_, _tmp69_);
		_tmp71_ = _tmp70_;
		_g_free0 (_tmp69_);
		_g_free0 (_tmp67_);
		button = _tmp71_;
		_tmp72_ = button;
		g_signal_connect_object ((GtkButton*) _tmp72_, "clicked", (GCallback) ____lambda32__gtk_button_clicked, self, 0);
		_g_object_unref0 (button);
	}
	_tmp73_ = g_build_filename (PKGDATADIR, "dialog_close.png", NULL);
	_tmp74_ = _tmp73_;
	_tmp75_ = g_build_filename (PKGDATADIR, "dialog_close_highlight.png", NULL);
	_tmp76_ = _tmp75_;
	_tmp77_ = dialog_button_new (_tmp74_, _tmp76_, NULL);
	g_object_ref_sink (_tmp77_);
	_g_object_unref0 (self->priv->close_button);
	self->priv->close_button = _tmp77_;
	_g_free0 (_tmp76_);
	_g_free0 (_tmp74_);
	_tmp78_ = self->priv->close_button;
	g_object_set ((GtkWidget*) _tmp78_, "can-focus", FALSE, NULL);
	_tmp79_ = self->priv->close_button;
	g_signal_connect_object ((GtkButton*) _tmp79_, "clicked", (GCallback) ___lambda33__gtk_button_clicked, self, 0);
	_tmp80_ = self->priv->close_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp80_, TRUE);
	_tmp81_ = self->priv->close_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp81_);
	_g_object_unref0 (label);
	_g_free0 (text);
	_g_object_unref0 (title_label);
	return self;
}


ShutdownDialog* shutdown_dialog_new (ShutdownDialogType type) {
	return shutdown_dialog_construct (TYPE_SHUTDOWN_DIALOG, type);
}


void shutdown_dialog_focus_next (ShutdownDialog* self) {
	GtkWidget* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	g_signal_emit_by_name ((GtkWidget*) (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp0_) : NULL), "move-focus", GTK_DIR_TAB_FORWARD);
}


void shutdown_dialog_focus_prev (ShutdownDialog* self) {
	GtkWidget* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	g_signal_emit_by_name ((GtkWidget*) (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp0_) : NULL), "move-focus", GTK_DIR_TAB_BACKWARD);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void shutdown_dialog_cancel (ShutdownDialog* self) {
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_;
	GtkWidget* widget;
	GtkWidget* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	_tmp1_ = gtk_window_get_focus (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp0_) : NULL);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	widget = _tmp2_;
	_tmp3_ = widget;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, TYPE_DIALOG_BUTTON)) {
		GtkWidget* _tmp4_ = NULL;
		_tmp4_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		gtk_window_set_focus (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp4_) : NULL, NULL);
	} else {
		g_signal_emit_by_name (self, "close");
	}
	_g_object_unref0 (widget);
}


static void shutdown_dialog_real_size_allocate (GtkWidget* base, GtkAllocation* allocation) {
	ShutdownDialog * self;
	GtkAllocation _tmp0_;
	GtkAllocation content_allocation = {0};
	gint minimum_width = 0;
	gint natural_width = 0;
	gint minimum_height = 0;
	gint natural_height = 0;
	GtkBox* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GtkBox* _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GtkAllocation _tmp13_;
	gint _tmp14_;
	GtkAllocation _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	GtkBox* _tmp20_;
	GtkAllocation _tmp21_;
	GtkAllocation a = {0};
	DialogButton* _tmp22_;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	DialogButton* _tmp25_;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	GtkAllocation _tmp28_;
	gint _tmp29_;
	GtkAllocation _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	DialogButton* _tmp34_;
	GtkAllocation _tmp35_;
	self = (ShutdownDialog*) base;
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	GTK_WIDGET_CLASS (shutdown_dialog_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_FIXED, GtkFixed), &_tmp0_);
	memset (&content_allocation, 0, sizeof (GtkAllocation));
	_tmp1_ = self->priv->vbox;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp1_, &_tmp2_, &_tmp3_);
	minimum_width = _tmp2_;
	natural_width = _tmp3_;
	_tmp4_ = self->priv->vbox;
	_tmp5_ = minimum_width;
	gtk_widget_get_preferred_height_for_width ((GtkWidget*) _tmp4_, _tmp5_, &_tmp6_, &_tmp7_);
	minimum_height = _tmp6_;
	natural_height = _tmp7_;
	_tmp8_ = *allocation;
	_tmp9_ = _tmp8_.x;
	_tmp10_ = *allocation;
	_tmp11_ = _tmp10_.width;
	_tmp12_ = minimum_width;
	content_allocation.x = _tmp9_ + ((_tmp11_ - _tmp12_) / 2);
	_tmp13_ = *allocation;
	_tmp14_ = _tmp13_.y;
	_tmp15_ = *allocation;
	_tmp16_ = _tmp15_.height;
	_tmp17_ = minimum_height;
	content_allocation.y = _tmp14_ + ((_tmp16_ - _tmp17_) / 2);
	_tmp18_ = minimum_width;
	content_allocation.width = _tmp18_;
	_tmp19_ = minimum_height;
	content_allocation.height = _tmp19_;
	_tmp20_ = self->priv->vbox;
	_tmp21_ = content_allocation;
	gtk_widget_size_allocate ((GtkWidget*) _tmp20_, &_tmp21_);
	memset (&a, 0, sizeof (GtkAllocation));
	_tmp22_ = self->priv->close_button;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp22_, &_tmp23_, &_tmp24_);
	minimum_width = _tmp23_;
	natural_width = _tmp24_;
	_tmp25_ = self->priv->close_button;
	gtk_widget_get_preferred_height ((GtkWidget*) _tmp25_, &_tmp26_, &_tmp27_);
	minimum_height = _tmp26_;
	natural_height = _tmp27_;
	_tmp28_ = content_allocation;
	_tmp29_ = _tmp28_.x;
	a.x = (_tmp29_ - SHUTDOWN_DIALOG_BORDER_SIZE) + SHUTDOWN_DIALOG_CLOSE_OFFSET;
	_tmp30_ = content_allocation;
	_tmp31_ = _tmp30_.y;
	a.y = (_tmp31_ - SHUTDOWN_DIALOG_BORDER_SIZE) + SHUTDOWN_DIALOG_CLOSE_OFFSET;
	_tmp32_ = minimum_width;
	a.width = _tmp32_;
	_tmp33_ = minimum_height;
	a.height = _tmp33_;
	_tmp34_ = self->priv->close_button;
	_tmp35_ = a;
	gtk_widget_size_allocate ((GtkWidget*) _tmp34_, &_tmp35_);
}


static gboolean shutdown_dialog_real_draw (GtkWidget* base, cairo_t* c) {
	ShutdownDialog * self;
	gboolean result = FALSE;
	cairo_surface_t* _tmp0_;
	GtkBox* _tmp18_;
	gint _tmp19_ = 0;
	gint width;
	GtkBox* _tmp20_;
	gint _tmp21_ = 0;
	gint height;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	cairo_matrix_t m = {0};
	cairo_pattern_t* _tmp28_;
	cairo_matrix_t _tmp29_;
	cairo_t* _tmp30_;
	cairo_pattern_t* _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_pattern_t* _tmp34_;
	cairo_matrix_t _tmp35_;
	cairo_t* _tmp36_;
	cairo_pattern_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_pattern_t* _tmp40_;
	cairo_matrix_t _tmp41_;
	cairo_t* _tmp42_;
	cairo_pattern_t* _tmp43_;
	cairo_t* _tmp44_;
	cairo_t* _tmp45_;
	cairo_pattern_t* _tmp46_;
	cairo_matrix_t _tmp47_;
	cairo_t* _tmp48_;
	cairo_pattern_t* _tmp49_;
	cairo_t* _tmp50_;
	cairo_t* _tmp51_;
	cairo_pattern_t* _tmp52_;
	cairo_matrix_t _tmp53_;
	cairo_t* _tmp54_;
	cairo_pattern_t* _tmp55_;
	cairo_t* _tmp56_;
	cairo_t* _tmp57_;
	cairo_pattern_t* _tmp58_;
	cairo_matrix_t _tmp59_;
	cairo_t* _tmp60_;
	cairo_pattern_t* _tmp61_;
	cairo_t* _tmp62_;
	cairo_t* _tmp63_;
	cairo_pattern_t* _tmp64_;
	cairo_matrix_t _tmp65_;
	cairo_t* _tmp66_;
	cairo_pattern_t* _tmp67_;
	cairo_t* _tmp68_;
	cairo_t* _tmp69_;
	cairo_pattern_t* _tmp70_;
	cairo_matrix_t _tmp71_;
	cairo_t* _tmp72_;
	cairo_pattern_t* _tmp73_;
	cairo_t* _tmp74_;
	cairo_t* _tmp75_;
	cairo_t* _tmp76_;
	cairo_t* _tmp77_;
	cairo_t* _tmp78_;
	cairo_t* _tmp79_;
	cairo_t* _tmp80_;
	gboolean _tmp81_ = FALSE;
	self = (ShutdownDialog*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = self->priv->corner_surface;
	if (_tmp0_ == NULL) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		cairo_surface_t* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		cairo_surface_t* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		cairo_pattern_t* _tmp11_;
		cairo_surface_t* _tmp12_;
		cairo_pattern_t* _tmp13_;
		cairo_pattern_t* _tmp14_;
		cairo_surface_t* _tmp15_;
		cairo_pattern_t* _tmp16_;
		cairo_pattern_t* _tmp17_;
		_tmp1_ = g_build_filename (PKGDATADIR, "switcher_corner.png", NULL);
		_tmp2_ = _tmp1_;
		_tmp3_ = cairo_image_surface_create_from_png (_tmp2_);
		_cairo_surface_destroy0 (self->priv->corner_surface);
		self->priv->corner_surface = _tmp3_;
		_g_free0 (_tmp2_);
		_tmp4_ = g_build_filename (PKGDATADIR, "switcher_left.png", NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = cairo_image_surface_create_from_png (_tmp5_);
		_cairo_surface_destroy0 (self->priv->left_surface);
		self->priv->left_surface = _tmp6_;
		_g_free0 (_tmp5_);
		_tmp7_ = g_build_filename (PKGDATADIR, "switcher_top.png", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = cairo_image_surface_create_from_png (_tmp8_);
		_cairo_surface_destroy0 (self->priv->top_surface);
		self->priv->top_surface = _tmp9_;
		_g_free0 (_tmp8_);
		_tmp10_ = self->priv->corner_surface;
		_tmp11_ = cairo_pattern_create_for_surface (_tmp10_);
		_cairo_pattern_destroy0 (self->priv->corner_pattern);
		self->priv->corner_pattern = _tmp11_;
		_tmp12_ = self->priv->left_surface;
		_tmp13_ = cairo_pattern_create_for_surface (_tmp12_);
		_cairo_pattern_destroy0 (self->priv->left_pattern);
		self->priv->left_pattern = _tmp13_;
		_tmp14_ = self->priv->left_pattern;
		cairo_pattern_set_extend (_tmp14_, CAIRO_EXTEND_REPEAT);
		_tmp15_ = self->priv->top_surface;
		_tmp16_ = cairo_pattern_create_for_surface (_tmp15_);
		_cairo_pattern_destroy0 (self->priv->top_pattern);
		self->priv->top_pattern = _tmp16_;
		_tmp17_ = self->priv->top_pattern;
		cairo_pattern_set_extend (_tmp17_, CAIRO_EXTEND_REPEAT);
	}
	_tmp18_ = self->priv->vbox;
	_tmp19_ = gtk_widget_get_allocated_width ((GtkWidget*) _tmp18_);
	width = (_tmp19_ + (20 * 2)) + (SHUTDOWN_DIALOG_BORDER_SIZE * 2);
	_tmp20_ = self->priv->vbox;
	_tmp21_ = gtk_widget_get_allocated_height ((GtkWidget*) _tmp20_);
	height = (_tmp21_ + (20 * 2)) + (SHUTDOWN_DIALOG_BORDER_SIZE * 2);
	_tmp22_ = c;
	cairo_set_source_rgba (_tmp22_, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	_tmp23_ = c;
	cairo_paint (_tmp23_);
	_tmp24_ = c;
	cairo_save (_tmp24_);
	_tmp25_ = c;
	_tmp26_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	_tmp27_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	cairo_translate (_tmp25_, (_tmp26_ - width) * 0.5, (_tmp27_ - height) * 0.5);
	cairo_matrix_init_identity (&m);
	_tmp28_ = self->priv->corner_pattern;
	_tmp29_ = m;
	cairo_pattern_set_matrix (_tmp28_, &_tmp29_);
	_tmp30_ = c;
	_tmp31_ = self->priv->corner_pattern;
	cairo_set_source (_tmp30_, _tmp31_);
	_tmp32_ = c;
	cairo_rectangle (_tmp32_, (gdouble) 0, (gdouble) 0, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE);
	_tmp33_ = c;
	cairo_fill (_tmp33_);
	cairo_matrix_init_identity (&m);
	cairo_matrix_translate (&m, (gdouble) width, (gdouble) 0);
	cairo_matrix_scale (&m, (gdouble) (-1), (gdouble) 1);
	_tmp34_ = self->priv->corner_pattern;
	_tmp35_ = m;
	cairo_pattern_set_matrix (_tmp34_, &_tmp35_);
	_tmp36_ = c;
	_tmp37_ = self->priv->corner_pattern;
	cairo_set_source (_tmp36_, _tmp37_);
	_tmp38_ = c;
	cairo_rectangle (_tmp38_, (gdouble) (width - SHUTDOWN_DIALOG_BORDER_SIZE), (gdouble) 0, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE);
	_tmp39_ = c;
	cairo_fill (_tmp39_);
	cairo_matrix_init_identity (&m);
	cairo_matrix_translate (&m, (gdouble) 0, (gdouble) height);
	cairo_matrix_scale (&m, (gdouble) 1, (gdouble) (-1));
	_tmp40_ = self->priv->corner_pattern;
	_tmp41_ = m;
	cairo_pattern_set_matrix (_tmp40_, &_tmp41_);
	_tmp42_ = c;
	_tmp43_ = self->priv->corner_pattern;
	cairo_set_source (_tmp42_, _tmp43_);
	_tmp44_ = c;
	cairo_rectangle (_tmp44_, (gdouble) 0, (gdouble) (height - SHUTDOWN_DIALOG_BORDER_SIZE), (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE);
	_tmp45_ = c;
	cairo_fill (_tmp45_);
	cairo_matrix_init_identity (&m);
	cairo_matrix_translate (&m, (gdouble) width, (gdouble) height);
	cairo_matrix_scale (&m, (gdouble) (-1), (gdouble) (-1));
	_tmp46_ = self->priv->corner_pattern;
	_tmp47_ = m;
	cairo_pattern_set_matrix (_tmp46_, &_tmp47_);
	_tmp48_ = c;
	_tmp49_ = self->priv->corner_pattern;
	cairo_set_source (_tmp48_, _tmp49_);
	_tmp50_ = c;
	cairo_rectangle (_tmp50_, (gdouble) (width - SHUTDOWN_DIALOG_BORDER_SIZE), (gdouble) (height - SHUTDOWN_DIALOG_BORDER_SIZE), (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE);
	_tmp51_ = c;
	cairo_fill (_tmp51_);
	cairo_matrix_init_identity (&m);
	_tmp52_ = self->priv->left_pattern;
	_tmp53_ = m;
	cairo_pattern_set_matrix (_tmp52_, &_tmp53_);
	_tmp54_ = c;
	_tmp55_ = self->priv->left_pattern;
	cairo_set_source (_tmp54_, _tmp55_);
	_tmp56_ = c;
	cairo_rectangle (_tmp56_, (gdouble) 0, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) (height - (SHUTDOWN_DIALOG_BORDER_SIZE * 2)));
	_tmp57_ = c;
	cairo_fill (_tmp57_);
	cairo_matrix_init_identity (&m);
	cairo_matrix_translate (&m, (gdouble) width, (gdouble) 0);
	cairo_matrix_scale (&m, (gdouble) (-1), (gdouble) 1);
	_tmp58_ = self->priv->left_pattern;
	_tmp59_ = m;
	cairo_pattern_set_matrix (_tmp58_, &_tmp59_);
	_tmp60_ = c;
	_tmp61_ = self->priv->left_pattern;
	cairo_set_source (_tmp60_, _tmp61_);
	_tmp62_ = c;
	cairo_rectangle (_tmp62_, (gdouble) (width - SHUTDOWN_DIALOG_BORDER_SIZE), (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) (height - (SHUTDOWN_DIALOG_BORDER_SIZE * 2)));
	_tmp63_ = c;
	cairo_fill (_tmp63_);
	cairo_matrix_init_identity (&m);
	_tmp64_ = self->priv->top_pattern;
	_tmp65_ = m;
	cairo_pattern_set_matrix (_tmp64_, &_tmp65_);
	_tmp66_ = c;
	_tmp67_ = self->priv->top_pattern;
	cairo_set_source (_tmp66_, _tmp67_);
	_tmp68_ = c;
	cairo_rectangle (_tmp68_, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) 0, (gdouble) (width - (SHUTDOWN_DIALOG_BORDER_SIZE * 2)), (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE);
	_tmp69_ = c;
	cairo_fill (_tmp69_);
	cairo_matrix_init_identity (&m);
	cairo_matrix_translate (&m, (gdouble) 0, (gdouble) height);
	cairo_matrix_scale (&m, (gdouble) 1, (gdouble) (-1));
	_tmp70_ = self->priv->top_pattern;
	_tmp71_ = m;
	cairo_pattern_set_matrix (_tmp70_, &_tmp71_);
	_tmp72_ = c;
	_tmp73_ = self->priv->top_pattern;
	cairo_set_source (_tmp72_, _tmp73_);
	_tmp74_ = c;
	cairo_rectangle (_tmp74_, (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE, (gdouble) (height - SHUTDOWN_DIALOG_BORDER_SIZE), (gdouble) (width - (SHUTDOWN_DIALOG_BORDER_SIZE * 2)), (gdouble) SHUTDOWN_DIALOG_BORDER_SIZE);
	_tmp75_ = c;
	cairo_fill (_tmp75_);
	_tmp76_ = c;
	dash_box_cairo_rounded_rectangle (_tmp76_, (gdouble) 20, (gdouble) 20, (gdouble) (width - 40), (gdouble) (height - 40), (gdouble) 5);
	_tmp77_ = c;
	cairo_set_source_rgba (_tmp77_, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
	_tmp78_ = c;
	cairo_fill (_tmp78_);
	_tmp79_ = c;
	cairo_restore (_tmp79_);
	_tmp80_ = c;
	_tmp81_ = GTK_WIDGET_CLASS (shutdown_dialog_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_FIXED, GtkFixed), _tmp80_);
	result = _tmp81_;
	return result;
}


static gboolean shutdown_dialog_real_button_press_event (GtkWidget* base, GdkEventButton* event) {
	ShutdownDialog * self;
	gboolean result = FALSE;
	self = (ShutdownDialog*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	g_signal_emit_by_name (self, "close");
	result = TRUE;
	return result;
}


static DialogButton* shutdown_dialog_add_button (ShutdownDialog* self, const gchar* text, const gchar* inactive_filename, const gchar* active_filename) {
	DialogButton* result = NULL;
	GtkBox* _tmp0_;
	GtkBox* b;
	GtkBox* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* label;
	PangoFontDescription* _tmp4_ = NULL;
	PangoFontDescription* _tmp5_;
	GdkRGBA _tmp6_ = {0};
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	DialogButton* _tmp9_;
	DialogButton* button;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	g_return_val_if_fail (inactive_filename != NULL, NULL);
	g_return_val_if_fail (active_filename != NULL, NULL);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 9);
	g_object_ref_sink (_tmp0_);
	b = _tmp0_;
	gtk_widget_set_visible ((GtkWidget*) b, TRUE);
	_tmp1_ = self->priv->button_box;
	gtk_box_pack_start (_tmp1_, (GtkWidget*) b, FALSE, FALSE, (guint) 0);
	_tmp2_ = text;
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	g_object_ref_sink (_tmp3_);
	label = _tmp3_;
	gtk_widget_set_visible ((GtkWidget*) label, TRUE);
	_tmp4_ = pango_font_description_from_string ("Ubuntu Light 12");
	_tmp5_ = _tmp4_;
	gtk_widget_override_font ((GtkWidget*) label, _tmp5_);
	__vala_PangoFontDescription_free0 (_tmp5_);
	_tmp6_.red = (gdouble) 1.0f;
	_tmp6_.green = (gdouble) 1.0f;
	_tmp6_.blue = (gdouble) 1.0f;
	_tmp6_.alpha = (gdouble) 0.0f;
	gtk_widget_override_color ((GtkWidget*) label, GTK_STATE_FLAG_NORMAL, &_tmp6_);
	_tmp7_ = inactive_filename;
	_tmp8_ = active_filename;
	_tmp9_ = dialog_button_new (_tmp7_, _tmp8_, label);
	g_object_ref_sink (_tmp9_);
	button = _tmp9_;
	gtk_widget_set_visible ((GtkWidget*) button, TRUE);
	gtk_box_pack_start (b, (GtkWidget*) button, FALSE, FALSE, (guint) 0);
	gtk_box_pack_start (b, (GtkWidget*) label, FALSE, FALSE, (guint) 0);
	result = button;
	_g_object_unref0 (label);
	_g_object_unref0 (b);
	return result;
}


static void shutdown_dialog_class_init (ShutdownDialogClass * klass) {
	shutdown_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ShutdownDialogPrivate));
	GTK_WIDGET_CLASS (klass)->size_allocate = shutdown_dialog_real_size_allocate;
	GTK_WIDGET_CLASS (klass)->draw = shutdown_dialog_real_draw;
	GTK_WIDGET_CLASS (klass)->button_press_event = shutdown_dialog_real_button_press_event;
	G_OBJECT_CLASS (klass)->finalize = shutdown_dialog_finalize;
	g_signal_new ("close", TYPE_SHUTDOWN_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void shutdown_dialog_instance_init (ShutdownDialog * self) {
	self->priv = SHUTDOWN_DIALOG_GET_PRIVATE (self);
	self->priv->corner_surface = NULL;
	self->priv->left_surface = NULL;
	self->priv->top_surface = NULL;
	self->priv->corner_pattern = NULL;
	self->priv->left_pattern = NULL;
	self->priv->top_pattern = NULL;
}


static void shutdown_dialog_finalize (GObject* obj) {
	ShutdownDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHUTDOWN_DIALOG, ShutdownDialog);
	_cairo_surface_destroy0 (self->priv->corner_surface);
	_cairo_surface_destroy0 (self->priv->left_surface);
	_cairo_surface_destroy0 (self->priv->top_surface);
	_cairo_pattern_destroy0 (self->priv->corner_pattern);
	_cairo_pattern_destroy0 (self->priv->left_pattern);
	_cairo_pattern_destroy0 (self->priv->top_pattern);
	_g_object_unref0 (self->priv->vbox);
	_g_object_unref0 (self->priv->close_button);
	_g_object_unref0 (self->priv->button_box);
	G_OBJECT_CLASS (shutdown_dialog_parent_class)->finalize (obj);
}


GType shutdown_dialog_get_type (void) {
	static volatile gsize shutdown_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&shutdown_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ShutdownDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shutdown_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ShutdownDialog), 0, (GInstanceInitFunc) shutdown_dialog_instance_init, NULL };
		GType shutdown_dialog_type_id;
		shutdown_dialog_type_id = g_type_register_static (GTK_TYPE_FIXED, "ShutdownDialog", &g_define_type_info, 0);
		g_once_init_leave (&shutdown_dialog_type_id__volatile, shutdown_dialog_type_id);
	}
	return shutdown_dialog_type_id__volatile;
}


DialogButton* dialog_button_construct (GType object_type, const gchar* inactive_filename, const gchar* active_filename, GtkLabel* label) {
	DialogButton * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	const gchar* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	g_return_val_if_fail (inactive_filename != NULL, NULL);
	g_return_val_if_fail (active_filename != NULL, NULL);
	self = (DialogButton*) g_object_new (object_type, NULL);
	_tmp0_ = inactive_filename;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->inactive_filename);
	self->priv->inactive_filename = _tmp1_;
	_tmp2_ = active_filename;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (self->priv->active_filename);
	self->priv->active_filename = _tmp3_;
	_tmp4_ = label;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->priv->l);
	self->priv->l = _tmp5_;
	gtk_button_set_relief ((GtkButton*) self, GTK_RELIEF_NONE);
	gtk_button_set_focus_on_click ((GtkButton*) self, FALSE);
	_tmp6_ = inactive_filename;
	_tmp7_ = (GtkImage*) gtk_image_new_from_file (_tmp6_);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->i);
	self->priv->i = _tmp7_;
	_tmp8_ = self->priv->i;
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
	_tmp9_ = self->priv->i;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
	return self;
}


DialogButton* dialog_button_new (const gchar* inactive_filename, const gchar* active_filename, GtkLabel* label) {
	return dialog_button_construct (TYPE_DIALOG_BUTTON, inactive_filename, active_filename, label);
}


static gboolean dialog_button_real_enter_notify_event (GtkWidget* base, GdkEventCrossing* event) {
	DialogButton * self;
	gboolean result = FALSE;
	GdkEventCrossing _tmp0_;
	gboolean _tmp1_ = FALSE;
	self = (DialogButton*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	gtk_widget_grab_focus ((GtkWidget*) self);
	_tmp0_ = *event;
	_tmp1_ = GTK_WIDGET_CLASS (dialog_button_parent_class)->enter_notify_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BUTTON, GtkButton), &_tmp0_);
	result = _tmp1_;
	return result;
}


static gboolean dialog_button_real_leave_notify_event (GtkWidget* base, GdkEventCrossing* event) {
	DialogButton * self;
	gboolean result = FALSE;
	GtkWidget* _tmp0_ = NULL;
	GdkEventCrossing _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (DialogButton*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
	gtk_window_set_focus (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_WINDOW) ? ((GtkWindow*) _tmp0_) : NULL, NULL);
	_tmp1_ = *event;
	_tmp2_ = GTK_WIDGET_CLASS (dialog_button_parent_class)->leave_notify_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BUTTON, GtkButton), &_tmp1_);
	result = _tmp2_;
	return result;
}


static gboolean dialog_button_real_focus_in_event (GtkWidget* base, GdkEventFocus* event) {
	DialogButton * self;
	gboolean result = FALSE;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_;
	GdkEventFocus _tmp5_;
	gboolean _tmp6_ = FALSE;
	self = (DialogButton*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->i;
	_tmp1_ = self->priv->active_filename;
	gtk_image_set_from_file (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->l;
	if (_tmp2_ != NULL) {
		GtkLabel* _tmp3_;
		GdkRGBA _tmp4_ = {0};
		_tmp3_ = self->priv->l;
		_tmp4_.red = (gdouble) 1.0f;
		_tmp4_.green = (gdouble) 1.0f;
		_tmp4_.blue = (gdouble) 1.0f;
		_tmp4_.alpha = (gdouble) 1.0f;
		gtk_widget_override_color ((GtkWidget*) _tmp3_, GTK_STATE_FLAG_NORMAL, &_tmp4_);
	}
	_tmp5_ = *event;
	_tmp6_ = GTK_WIDGET_CLASS (dialog_button_parent_class)->focus_in_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BUTTON, GtkButton), &_tmp5_);
	result = _tmp6_;
	return result;
}


static gboolean dialog_button_real_focus_out_event (GtkWidget* base, GdkEventFocus* event) {
	DialogButton * self;
	gboolean result = FALSE;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_;
	GdkEventFocus _tmp5_;
	gboolean _tmp6_ = FALSE;
	self = (DialogButton*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->i;
	_tmp1_ = self->priv->inactive_filename;
	gtk_image_set_from_file (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->l;
	if (_tmp2_ != NULL) {
		GtkLabel* _tmp3_;
		GdkRGBA _tmp4_ = {0};
		_tmp3_ = self->priv->l;
		_tmp4_.red = (gdouble) 1.0f;
		_tmp4_.green = (gdouble) 1.0f;
		_tmp4_.blue = (gdouble) 1.0f;
		_tmp4_.alpha = (gdouble) 0.0f;
		gtk_widget_override_color ((GtkWidget*) _tmp3_, GTK_STATE_FLAG_NORMAL, &_tmp4_);
	}
	_tmp5_ = *event;
	_tmp6_ = GTK_WIDGET_CLASS (dialog_button_parent_class)->focus_out_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BUTTON, GtkButton), &_tmp5_);
	result = _tmp6_;
	return result;
}


static gboolean dialog_button_real_draw (GtkWidget* base, cairo_t* c) {
	DialogButton * self;
	gboolean result = FALSE;
	GtkImage* _tmp0_;
	cairo_t* _tmp1_;
	self = (DialogButton*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	_tmp0_ = self->priv->i;
	_tmp1_ = c;
	gtk_widget_draw ((GtkWidget*) _tmp0_, _tmp1_);
	result = TRUE;
	return result;
}


static void dialog_button_class_init (DialogButtonClass * klass) {
	dialog_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DialogButtonPrivate));
	GTK_WIDGET_CLASS (klass)->enter_notify_event = dialog_button_real_enter_notify_event;
	GTK_WIDGET_CLASS (klass)->leave_notify_event = dialog_button_real_leave_notify_event;
	GTK_WIDGET_CLASS (klass)->focus_in_event = dialog_button_real_focus_in_event;
	GTK_WIDGET_CLASS (klass)->focus_out_event = dialog_button_real_focus_out_event;
	GTK_WIDGET_CLASS (klass)->draw = dialog_button_real_draw;
	G_OBJECT_CLASS (klass)->finalize = dialog_button_finalize;
}


static void dialog_button_instance_init (DialogButton * self) {
	self->priv = DIALOG_BUTTON_GET_PRIVATE (self);
}


static void dialog_button_finalize (GObject* obj) {
	DialogButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIALOG_BUTTON, DialogButton);
	_g_free0 (self->priv->inactive_filename);
	_g_free0 (self->priv->active_filename);
	_g_object_unref0 (self->priv->i);
	_g_object_unref0 (self->priv->l);
	G_OBJECT_CLASS (dialog_button_parent_class)->finalize (obj);
}


GType dialog_button_get_type (void) {
	static volatile gsize dialog_button_type_id__volatile = 0;
	if (g_once_init_enter (&dialog_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DialogButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dialog_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DialogButton), 0, (GInstanceInitFunc) dialog_button_instance_init, NULL };
		GType dialog_button_type_id;
		dialog_button_type_id = g_type_register_static (GTK_TYPE_BUTTON, "DialogButton", &g_define_type_info, 0);
		g_once_init_leave (&dialog_button_type_id__volatile, dialog_button_type_id);
	}
	return dialog_button_type_id__volatile;
}



